;
; IRQovl/reset proof hrtmon for ACA620 by Toni Wilen.
;
; hrtmon source changes:
;
;	IFNE ACA620
;		ORG $ec0000
;	ENDC
;
;
;		dc.b "HRT!"
;monitor:	or	#$700,sr	;on 68060 it is granted that the first instruction
;					;is executed before any pending interupts, so we 
;					;stop them to avoid any confusing
;	IFNE ACA620
;		clr.w $b8f03c
;	ENDC
;		bset	#0,entered

ISROM = 1


AllocMem = -198
AllocAbs = -204
FreeMem = -210
AvailMem = -216
TypeOfMem = -$216
CacheClearU = -$27C
SuperVisor = -$01E
OpenLibrary = -$228
CloseLibrary = -$19E
Output = -$3C
Write = -$30

	include "aca.i"

HRTMON_BASE = $ec0000
	IF ISROM=1
TRAMPOLINE_BASE = $de8000
	ELSE
TRAMPOLINE_BASE = $ef8000
	ENDC
VBR_BASE = $400000
RESIDENT_BASE = $f70010
HRTSTORE_BASE = $f60000

	section hrt,code

	move.l 4.w,a6
	lea dos(pc),a1
	moveq #0,d0
	jsr OpenLibrary(a6)
	move.l d0,a5

	IF ISROM=0
	bra.w skip1
	ENDC

	lea exp(pc),a1
	moveq #0,d0
	jsr OpenLibrary(a6)
	move.l d0,a6
	move.l #4626,d0 ;vendor
	moveq #70,d1 ;product
	sub.l a0,a0
	jsr -$48(a6) ;FindConfigDev
	move.l d0,d2
	move.l a6,a1
	move.l 4.w,a6
	jsr CloseLibrary(a6)

	tst.l d2
	bne.s cdfound
	lea noaca(pc),a0
	bsr.w output
	bra.w end
cdfound:
	move.l d2,a0
	cmp.l #2,16+6(a0) ;serial
	bcc.s revfound
	lea oldaca(pc),a0
	bsr.w output
	bra.w end
revfound:

skip1:
	move.l #HRTMON_BASE+1024,a1
	jsr TypeOfMem(a6)
	tst.l d0
	bne.s meminuse
	move.l #RESIDENT_BASE+1024,a1
	jsr TypeOfMem(a6)
	tst.l d0
	beq.s memfree
	
meminuse:
	lea nomem(pc),a0
	bsr.w output
	bra.w end

memfree:
	bsr.w aca_init

	move.l #ACA_BASE,a4

	lea acacode(pc),a0
	lea acacodeend(pc),a1
	move.l #TRAMPOLINE_BASE,a2
acacodecopy:
	move.l (a0)+,(a2)+
	cmp.l a1,a0
	bne.s acacodecopy
	
	bsr.w copyresidentcode

	bsr.w depack

	cmp.w #36,20(a6)
	bcs.s noccu
	jsr CacheClearU(a6)
noccu:

	lea HRTMON_BASE,a0
	moveq #-1,d0
	move.b d0,41(a0) ;hexmode

	jsr 8(a0) ;mon_install

	move.w HRTMON_BASE+12+2,a3
	add.l #HRTMON_BASE+12+2,a3
	move.l a3,$7c.w
	move.l #VBR_BASE,a2
	jsr TRAMPOLINE_BASE

	lea installed(pc),a0
	bsr.w output

end:
	move.l a5,a1
	jsr CloseLibrary(a6)

	moveq #0,d0
	rts	

	cnop 0,4
acacode:
	jsr -$78(a6)
	move.w #$0000,$38(a4) ;rom protect off
	sub.l a0,a0
	move.l a2,a1
	move.w #1024/4-1,d0
acac1:
	move.l (a0)+,(a1)+
	dbf d0,acac1
	move.l a3,$7c(a2)
	move.w #$8000,$38(a4) ;rom protect on
	jsr -$7e(a6)
	rts
	cnop 0,4
acacodeend:

copyresidentcode:
	move.w #$8000,$34(a4) ;maxmem off
	move.w #$0000,$38(a4) ;rom protect off

	move.l #RESIDENT_BASE,a0
	move.l a0,a2
	move.w #$4afc,(a0)+
	move.l a2,(a0)+
	move.l a2,a1
	add.w #residentcodeend-residentcode+26+2,a1
	move.l a1,(a0)+
	move.l #$01020028,(a0)+
	move.l a2,a1
	add.w #residentname-residentcode+26,a1
	move.l a1,(a0)+
	move.l a1,(a0)+
	move.l a2,a1
	add.w #26,a1
	move.l a1,(a0)+
	lea residentcode(pc),a1
	lea residentcodeend(pc),a2
copyres:
	move.l (a1)+,(a0)+
	cmp.l a1,a2
	bne.s copyres

	lea hrtdata(pc),a0
	move.l a0,a1
	add.l #hrtdataend-hrtdata,a1
	move.l #HRTSTORE_BASE,a2
copyhrt:
	move.l (a0)+,(a2)+
	cmp.l a0,a1
	bne.s copyhrt

	move.w #$8000,$38(a4) ;rom protect on
	move.w #$0000,$34(a4) ;maxmem on
	rts
	
	cnop 0,4
residentcode:
	movem.l d2-d7/a2-a6,-(sp)

	lea residentcodet(pc),a0
	lea residentcodete(pc),a1
	move.l a1,d0
	lea TRAMPOLINE_BASE,a1
rtc1:
	move.l (a0)+,(a1)+
	cmp.l a0,d0
	bne.s rtc1

	cmp.w #36,20(a6)
	bcs.s .noccu1
	jsr CacheClearU(a6)
.noccu1

	jsr TRAMPOLINE_BASE

	bsr.w depack

	cmp.w #36,20(a6)
	bcs.s .noccu2
	jsr CacheClearU(a6)
.noccu2

	lea HRTMON_BASE,a0
	jsr 8(a0) ;mon_install

	jsr TRAMPOLINE_BASE+(residentcodet2-residentcodet)

	movem.l (sp)+,d2-d7/a2-a6
	moveq #0,d0
	rts

	cnop 0,4

residentcodet:
	jsr -$78(a6)

	move.l #ACA_BASE,a0
	moveq #0,d0
	moveq #-1,d1
	move.w d1,(a0)
	move.w d0,4(a0)
	move.w d1,8(a0)
	move.w d1,$c(a0)

	move.w d0,$3c(a0) ;irqovl off
	move.w d1,$38(a0) ;protect on
	move.w d0,$34(a0) ;maxmem on

	jsr -$7e(a6)
	rts

residentcodet2:
	jsr -$78(a6)

	lea HRTMON_BASE,a2
	move.w 12+2(a2),a1
	add.l a2,a1
	lea 12+2(a1),a1
	move.w d0,$38(a0) ;rom protect off (& maxmem on = special mapping on)
	move.l a1,VBR_BASE+$7c
	move.w d1,$38(a0) ;rom protect on
	move.l a1,$7c.w

	jsr -$7e(a6)
	rts

depack
	lea HRTSTORE_BASE,a1
	lea HRTMON_BASE,a0
	incbin "sys:source/bin/optidec.bin"

	cnop 0,4
residentcodete:
residentname:
	dc.b "ACA620 HRTmon",0
	cnop 0,4
residentcodeend:

output:
	exg a5,a6
	move.l a0,d2
	moveq #0,d3
outlen:
	addq.l #1,d3
	tst.b (a0)+
	bne.s outlen
	jsr Output(a6)
	move.l d0,d1
	beq.s noout
	jsr Write(a6)
noout:
	exg a5,a6
	rts

dos:
	dc.b "dos.library",0
exp:
	dc.b "expansion.library",0
nomem:
	dc.b "F0 memory region in use by system.",10,0
noaca:
	dc.b "ACA620 not detected.",10,0
oldaca:
	dc.b "ACA620 revision 2 required.",10,0
installed:
	dc.b "ACA620 HRTmon installed",10,0
	even
	
	include "aca_init.s"

	cnop 0,4
hrtdata:
	incbin "hrtmon_aca620.data.stc"
	cnop 0,4
hrtdataend:
